<!--中间模块-->
<template >
  <div class="center-module">
    <div class="center-module-top">
      <ModuleBgBox :name="item.titleName" v-for="(item,index) in gaugeData" :key="index">
        <div class="content">
          <div class="gauge-ele" :id="`gauge${index}`"></div >
          <div class="rank-box"
          >
            <img :src="require(`@/assets/img/inportantCity/${item.rankImg}`)" alt="">
            <div class="name">{{ item.name }}</div >
            <div class="rank">
              <span >{{ item.rank }}</span >名
            </div >
          </div >
        </div >
      </ModuleBgBox >
    </div >
    <div class="center-module-bottom">
      <ModuleBgBox name="改革需求">
        <div class="center-module-bottom-left">
          <div class="content-left">
            <div class="divider">分析力</div >
            <div id="pictorialBar"></div >
          </div >
          <div class="content-right">
            <div class="divider">落实力</div >
            <div class="box1">
              <div class="top-text">任务总量</div >
              <div class="bottom-text">
                <span >10</span >项
              </div >
            </div >
            <img src="@/assets/img/inportantCity/箭头.png"/>
            <div class="content">
              <div class="box2">
                <div class="top-text">任务总量</div >
                <div class="bottom-text">
                  <span >10</span >项
                </div >
              </div >
              <div class="box2">
                <div class="top-text">任务总量</div >
                <div class="bottom-text">
                  <span >10</span >项
                </div >
              </div >
            </div >
          </div >
        </div >
      </ModuleBgBox >
      <ModuleBgBox name="问题破解">
        <div class="center-module-bottom-right">
          <div class="divider">管理闭环</div >
          <div class="statist-box">
            <div class="box">
              任务总量 <span style="color: #77CEAF">18</span > 项
            </div >
            <div class="box">
              推进中 <span style="color: #F3C584">17</span > 项
            </div >
            <div class="box">
              已完成 <span style="color: #F3C584">1</span > 项
            </div >
          </div >
          <div class="divider">典型案例</div >
          <vue-seamless-scroll
            class="scroll-list"
            :data="iterationList"
            :class-option="optionSingleHeightTime"
          >
            <div
              class="scroll-list-li"
              v-for="(_item, _index) in iterationList"
              :key="_index"
            >
              <span > {{ _item.name }}</span >
            </div >
          </vue-seamless-scroll >
          <div class="more-btn">查看更多</div >
        </div >
      </ModuleBgBox >
    </div >
  </div >
</template >
<script >
import ModuleBgBox from '@/views/BigScreen/components/ModuleBgBox.vue'
import * as echarts from 'echarts'
import VueSeamlessScroll from 'vue-seamless-scroll'
import pictorialBar1 from '@/assets/img/inportantCity/pictorialBar1.png'
import pictorialBar2 from '@/assets/img/inportantCity/pictorialBar2.png'
import pictorialBar3 from '@/assets/img/inportantCity/pictorialBar3.png'

export default {
  components: {ModuleBgBox, VueSeamlessScroll},
  name: 'CenterModule',
  computed: {
    optionSingleHeightTime() {
      return {
        step: 0.1
      }
    }
  },
  // 中间模块
  data() {
    return {
      /**
       * @gaugeData 顶部模块配置数组
       * @titleName  模块标题名
       * @name 模块标题名
       * @rank 排名
       * @score 分数
       * @gaugeBgColor 仪表盘颜色
       * @gaugeInstance 仪表盘实例对象
       * @rankImg 排名背景图片
       * */
      gaugeData: [
        {
          titleName: '综合评价指数',
          name: '全市排名',
          rank: 32,
          score: 33,
          gaugeBgColor: 'rgba(53,254,244,1)',
          gaugeInstance: null,
          rankImg: '组 20.png'
        },
        {
          titleName: '改革落实力指数',
          name: '全市排名',
          rank: 20,
          score: 20,
          gaugeBgColor: 'rgba(8,139,255,1)',
          gaugeInstance: null,
          rankImg: '组 4.png'
        },
        {
          titleName: '改革满意度指数',
          name: '全市排名',
          rank: 20,
          score: 20,
          gaugeBgColor: 'rgba(255,252,136,1)',
          gaugeInstance: null,
          rankImg: '组 4(1).png'
        },
        {
          titleName: '品牌显示度指数',
          name: '全市排名',
          rank: 20,
          score: 20,
          gaugeBgColor: 'rgba(37,184,205,1)',
          gaugeInstance: null,
          rankImg: '组 4(2).png'
        }
      ],
      iterationList: [
        {
          id: 1,
          name: '推动数字重庆建设',
          score: 31,
          sn: 1,
          trend: 0
        },
        {
          id: 2,
          name: '探索经济区与行政区适度分离改革',
          score: 26,
          sn: 2,
          trend: 1
        },
        {
          id: 3,
          name: '探索制造业“亩均论英雄”改革',
          score: 23,
          sn: 3,
          trend: 1
        },
        {
          id: 4,
          name: '实施国企战略性重组和专业化整合',
          score: 22,
          sn: 4,
          trend: 1
        },
        {
          id: 5,
          name: '建立企业上市助推机制',
          score: 21,
          sn: 5,
          trend: 2
        },
        {
          id: 6,
          name: '探索强村富民综合改革',
          score: 15,
          sn: 6,
          trend: 1
        },
        {
          id: 7,
          name: '全市开发区（园区）数',
          score: 13,
          sn: 7,
          trend: 1
        },
        {
          id: 8,
          name: '推进涉企涉民服务全生命周期“一件事一次办”',
          score: 12,
          sn: 8,
          trend: 1
        },
        {
          id: 9,
          name: '打造“信用重庆”升级版',
          score: 11,
          sn: 9,
          trend: 2
        },
        {
          id: 10,
          name: '探索制造业“亩均论英雄”改革',
          score: 9,
          sn: 10,
          trend: 1
        },
        {
          id: 11,
          name: '健全平安重庆风险闭环管控机制',
          score: 7,
          sn: 11,
          trend: 2
        },

        {
          id: 12,
          name: '推进渝警数智“情指行”一体化现代警务改革',
          score: 5,
          sn: 12,
          trend: 1
        },
        {
          id: 13,
          name: '建立领导班子运行评估和群众口碑评价机制',
          score: 4,
          sn: 13,
          trend: 2
        },
        {
          id: 14,
          name: '推进“党建扎桩·治理结网”基层治理现代化改革',
          score: 3,
          sn: 14,
          trend: 1
        },
        {
          id: 15,
          name: '实施投融资多元化改革',
          score: 2,
          sn: 15,
          trend: 1
        }
      ], // 问题破解列表
      pictogram: null // 象形图实例对象
    }
  },
  created() {
  },
  mounted() {
    this.initGauge()
    this.initPictogram()
  },
  methods: {
    // 仪表盘加载
    initGauge() {
      let option = {}
      this.gaugeData.forEach((item, index) => {
        option = {
          tooltip: {              // 本系列特定的 tooltip 设定。
            show: true,
            formatter: '{a}： {c}分',
            backgroundColor: item.gaugeBgColor,  // 提示框浮层的背景颜色。注意：series.tooltip 仅在 tooltip.trigger 为 'item' 时有效。
            borderColor: '#333',        // 提示框浮层的边框颜色。...
            borderWidth: 0,             // 提示框浮层的边框宽。...
            padding: 10,                 // 提示框浮层内边距，单位px，默认各方向内边距为5，接受数组分别设定上右下左边距。...
            textStyle: {
              color: '#252525',
              fontSize: 14
              // 提示框浮层的文本样式。...
              // color ,fontStyle ,fontWeight ,fontFamily ,fontSize ,lineHeight ,.......
            }
          },
          series: [{
            name: item.titleName,
            type: 'gauge',
            radius: '95%',
            center: ['50%', '62%'],
            min: 20,                 // 最小的数据值,默认 0 。映射到 minAngle。
            max: 100,               // 最大的数据值,默认 100 。映射到 maxAngle。
            splitNumber: 4,        // 仪表盘刻度的分割段数,默认 10。
            startAngle: 215,        // 仪表盘起始角度,默认 225。圆心 正右手侧为0度，正上方为90度，正左手侧为180度。
            endAngle: -35,          // 仪表盘结束角度,默认 -45
            detail: {               // 仪表盘详情，用于显示数据。
              show: true,             // 是否显示详情,默认 true。
              offsetCenter: [0, '65%'],// 相对于仪表盘中心的偏移位置，数组第一项是水平方向的偏移，第二项是垂直方向的偏移。可以是绝对的数值，也可以是相对于仪表盘半径的百分比。
              color: item.gaugeBgColor,          // 文字的颜色,默认 auto。
              fontSize: 25,           // 文字的字体大小,默认 15。
              formatter: '{value}分',  // 格式化函数或者字符串
              opacity: 0.7
            },
            data: [{
              value: item.score,
              name: '指数'
            }],
            axisLine: {
              show: true,
              lineStyle: {
                color: [
                  [
                    1, new echarts.graphic.LinearGradient(0, 0, 0, 1, [
                    {
                      offset: 1,
                      color: 'rgba(8,62,142,0.8)'
                    },
                    {
                      offset: 0.3,
                      color: item.gaugeBgColor
                    },
                    {
                      offset: 1,
                      color: 'rgba(8,62,142,0.8)'
                    }
                  ])
                  ]

                ],
                opacity: 0.8,                 //图形透明度。支持从 0 到 1 的数字，为 0 时不绘制该图形。
                width: 8,                  //轴线宽度,默认 30。
                shadowBlur: 1,             //(发光效果)图形阴影的模糊大小。该属性配合 shadowColor,shadowOffsetX, shadowOffsetY 一起设置图形的阴影效果。
                shadowColor: '#205396'        //阴影颜色。支持的格式同color。
              }
            },
            splitLine: {            // 分隔线样式。
              show: true,             // 是否显示分隔线,默认 true。
              length: 15,             // 分隔线线长。支持相对半径的百分比,默认 30。
              lineStyle: {            // 分隔线样式。
                color: item.gaugeBgColor,              //线的颜色,默认 #eee。
                opacity: 1,                 //图形透明度。支持从 0 到 1 的数字，为 0 时不绘制该图形。
                width: 3,                   //线度,默认 2。
                type: 'solid'              //线的类型,默认 solid。 此外还有 dashed,dotted
              }
            },
            axisTick: {             // 刻度(线)样式。
              show: true,             // 是否显示刻度(线),默认 true。
              splitNumber: 10,         // 分隔线之间分割的刻度数,默认 5。
              length: 9,              // 刻度线长。支持相对半径的百分比,默认 8。
              lineStyle: {            // 刻度线样式。
                color: '#476fa8',              //线的颜色,默认 #eee。
                opacity: 0.9,                 //图形透明度。支持从 0 到 1 的数字，为 0 时不绘制该图形。
                width: 1,                   //线度,默认 1。
                type: 'solid'              //线的类型,默认 solid。 此外还有 dashed,dotted
              }
            },
            axisLabel: {            // 刻度标签。
              show: true,             // 是否显示标签,默认 true。
              distance: 17,            // 标签与刻度线的距离,默认 5。
              color: '#fff',          // 文字的颜色,默认 #fff。
              fontSize: 15,           // 文字的字体大小,默认 5。
              formatter: '{value}'  // 刻度标签的内容格式器，支持字符串模板和回调函数两种形式。 示例:// 使用字符串模板，模板变量为刻度默认标签 {value},如:formatter: '{value} kg'; // 使用函数模板，函数参数分别为刻度数值,如formatter: function (value) {return value + 'km/h';}
            },
            pointer: {              // 仪表盘指针。
              show: true,             // 是否显示指针,默认 true。
              length: '35%',          // 指针长度，可以是绝对数值，也可以是相对于半径的百分比,默认 80%。
              width: 4            // 指针宽度,默认 8。
            },
            itemStyle: {            // 仪表盘指针样式。
              color: item.gaugeBgColor,          // 指针颜色，默认(auto)取数值所在的区间的颜色
              opacity: 1,             // 图形透明度。支持从 0 到 1 的数字，为 0 时不绘制该图形。
              borderType: 'solid',   // 柱条的描边类型，默认为实线，支持 'solid', 'dashed', 'dotted'。
              shadowBlur: 2,             //(发光效果)图形阴影的模糊大小。该属性配合 shadowColor,shadowOffsetX, shadowOffsetY 一起设置图形的阴影效果。
              shadowColor: item.gaugeBgColor       //阴影颜色。支持的格式同color。
            },
            title: {                // 仪表盘标题。
              show: false             // 是否显示标题,默认 true。
            }


          }]
        }
        item.gaugeInstance = echarts.init(
          document.getElementById(`gauge${index}`)
        )
        option && item.gaugeInstance.setOption(option)
        window.addEventListener('resize', () => item.gaugeInstance.resize())
      })
    },

    // 象形图加载
    initPictogram() {
      // 定义标题
      const title = (text, top, left, color, fontStyle, fontFamily, fontSize) => {
        return {
          text: text,
          top: top,
          left: left,
          textStyle: {
            color: color,
            fontStyle: fontStyle,
            fontFamily: fontFamily,
            fontSize: fontSize
          }
        }
      }
      let option = {
        // 定义标题 需根据效果图 来微调
        title: [
          title('3项 排名1', '22%', '38%', 'white', 'normal', 'sans-serif', '12'),
          title('转化为清单', '28%', '36.5%', '#222', 'normal', 'sans-serif', '12'),
          title(`10项 排名3`, '38%', '36.5%', 'white', 'normal', 'sans-serif', '12'),
          title(`纳入全库量`, '46%', '36.5%', '#222', 'normal', 'sans-serif', '12'),
          title(`20项 排名5`, '55%', '36.5%', 'white', 'normal', 'sans-serif', '12'),
          title(`提出需求`, '63%', '38%', '#222', 'normal', 'sans-serif', '12')
        ],
        color: ['#bb0004', '#FFD48A'],
        grid: {left: '18%', top: '29%', bottom: '0%', right: 0},
        xAxis: {
          show: true,
          data: ['', '', '', ''], // 分成4分 必须有
          axisTick: {
            show: false
          },
          axisLabel: {
            color: '#5EA2ED',
            interval: 0
          },
          axisLine: {
            lineStyle: {
              color: '#1B5BBA'
            }
          }
        },
        yAxis: {
          show: false,
          splitLine: {show: false}
        },
        series: [
          {
            type: 'pictorialBar',
            legendHoverLink: false,
            label: {
              show: false
            },
            // 高亮配置
            emphasis: {
              disabled: false,
              // focus: "self",
              focus: 'none',
              blurScope: 'global'
            },
            hoverAnimation: true,
            data: [
              {
                name: '指标一',
                z: 100,
                value: 20,
                // symbolSize: [123.21, 107.77],
                symbolSize: ['220%', '100%'], // 图片的大小  建议使用百分比 方便自适应
                symbolPosition: 'center',
                // symbolOffset: [72, -195],
                symbolOffset: ['69%', '-256%'], // 图片的相对位置
                // 图片：在图片地址前加入image:// + 网络地址
                symbol: `image://${pictorialBar1}`
              },
              {
                name: '指标二',
                z: 100,
                value: 40,
                // symbolSize: [209.34, 81.25],
                symbolSize: ['376%', '46.7%'],
                symbolPosition: 'center',
                // symbolOffset: [-20, -50],
                symbolOffset: ['1.8%', '-143%'],
                symbol: `image://${pictorialBar2}`
              },
              {
                name: '指标三',
                z: 100,
                value: 60,
                // symbolSize: [291, 140],
                symbolSize: ['520%', '39.5%'],
                symbolPosition: 'center',
                // symbolOffset: [-100, 50],
                symbolOffset: ['-26.3%', '-15.5%'],
                symbol: `image://${pictorialBar3}`
              }
            ]
          }
        ]
      }
      this.pictogram = echarts.init(
        document.getElementById(`pictorialBar`)
      )
      option && this.pictogram.setOption(option)
      window.addEventListener('resize', () => this.pictogram.resize())

    }


  }
}
</script >
<style scoped lang="scss">
.center-module {
  width: 100%;
  height: 100%;
  display: flex;
  flex-direction: column;
  row-gap: 14px;

  .center-module-top {
    width: 100%;
    height: 62%;
    display: flex;
    column-gap: 4px;

    > div {
      flex: 1;

      .content {
        width: 100%;
        height: 100%;

        .gauge-ele {
          width: 100%;
          height: 45%;
        }

        .rank-box {
          width: 100%;
          height: 55%;
          background-size: 100% 100%;
          background-repeat: no-repeat;
          position: relative;

          img {
            position: absolute;
            left: 50%;
            transform: translateX(-50%);
            width: 75%;
            height: 90%;
            top: 8%;
          }

          .name {
            width: 100%;
            position: absolute;
            font-size: 18px;
            color: #FFFFFF;
            line-height: 22px;
            text-align: center;
            top: 68%;
          }

          .rank {
            width: 100%;
            position: absolute;
            font-size: 16px;
            color: #FFFFFF;
            text-align: center;
            top: 22%;

            span {
              font-size: 36px;
            }
          }
        }
      }
    }
  }

  .center-module-bottom {
    width: 100%;
    height: 38%;
    display: flex;
    column-gap: 14px;

    .divider {
      width: 100%;
      height: 7%;
      font-size: 16px;
      color: #FFFFFF;
      text-shadow: 0 0 16px #266BF2;
      text-align: center;
      padding: 3% 0;
      position: relative;

      &::after, &::before {
        position: absolute;
        content: '';
        width: 20%;
        height: 10%;
        top: 50%;
        transform: translateY(-50%);
        background-repeat: no-repeat;
        background-size: 100% 100%;
      }

      &::before {
        left: 8%;
        background-image: url("~@/assets/img/inportantCity/组 10.png");
      }

      &::after {
        right: 8%;
        background-image: url("~@/assets/img/inportantCity/组 10 拷贝.png");
      }
    }

    > div {
      flex: 1;

      .center-module-bottom-left {
        width: 100%;
        height: 100%;
        display: flex;
        box-sizing: border-box;
        padding-top: 2%;

        .content-left,
        .content-right {
          flex: 1;
          height: 100%;
        }

        .content-left {
          #pictorialBar {
            height: calc(100% - 28px);
          }
        }

        .content-right {
          display: flex;
          flex-direction: column;
          align-items: center;

          .box1 {
            width: 90%;
            height: 25%;
            background: rgba(2, 115, 233, 0.3);
            border: 1px solid #0273E9;
            box-sizing: border-box;
            display: flex;
            align-items: center;
            justify-content: center;
            flex-direction: column;
            row-gap: 10px;
            margin: 1% 0;

            .top-text {
              font-size: 16px;
              color: #D7F1FF;
            }

            .bottom-text {
              font-size: 13px;
              color: #D7F1FF;

              span {
                font-size: 16px;
                font-weight: bold;
                color: #FFFFFF;
                margin-right: 5px;
              }
            }
          }

          img {
            width: 15%;
            height: 15%;
            margin: 5% 0;
          }

          .content {
            width: 90%;
            height: 25%;
            display: flex;
            column-gap: 10px;

            .box2 {
              height: 100%;
              flex: 1;
              background: rgba(2, 115, 233, 0.3);
              border: 1px dashed #0273E9;
              box-sizing: border-box;
              display: flex;
              align-items: center;
              justify-content: center;
              flex-direction: column;
              row-gap: 10px;

              .top-text {
                font-size: 16px;
                color: #D7F1FF;
              }

              .bottom-text {
                font-size: 13px;
                color: #D7F1FF;

                span {
                  font-size: 16px;
                  font-weight: bold;
                  color: #FFFFFF;
                  margin-right: 5px;
                }
              }

            }
          }
        }
      }

      .center-module-bottom-right {
        width: 100%;
        height: 100%;
        padding: 0 29px;
        box-sizing: border-box;

        .statist-box {
          width: 100%;
          height: 15%;
          display: flex;
          column-gap: 9px;


          .box {
            height: 100%;
            flex: 1;
            text-align: center;
            display: flex;
            align-items: center;
            justify-content: center;
            font-size: 14px;
            color: #FFFFFF;
            background: url("~@/assets/img/inportantCity/1@2x.png") no-repeat 0 0;
            background-size: 100% 100%;

            span {
              font-size: 20px;
              margin: 0 5px;
            }
          }
        }

        .scroll-list {
          width: 100%;
          height: 25%;
          overflow: hidden;

          .scroll-list-li {
            height: 28px;
            line-height: 28px;
            padding-left: 9px;
            margin-bottom: 1px;
            position: relative;
            background: rgba(2, 115, 233, 0.1);

            span {
              font-size: 12px;
              color: #D7F1FF;
            }

            &:nth-last-child(1) {
              margin-bottom: 0;
            }
          }
        }

        .more-btn {
          position: absolute;
          bottom: 3%;
          left: 50%;
          transform: translateX(-50%);
          text-align: center;
          line-height: 36px;
          font-size: 14px;
          font-weight: 400;
          color: #fff;
          cursor: pointer;
          width: 30%;
          height: 32px;
          background: linear-gradient(90deg, #0777e1, #074ea3);
          border: 1px solid #0669cd;
          border-radius: 10px;
        }
      }
    }
  }
}
</style >
